"""Provides support for building strings based on commandline arguments.

The user can either specify two explicit strings, a value n such that
randomly generate strings of length n are used, or by default using
random strings of length 10. Examples:

   python lcs.py ACTAGGA ATGGAAG
   python lcs.py 15
   python lcs.py
   
"""
import sys
from random import choice

def parseArgs():
    if len(sys.argv) == 3:
        a,b = sys.argv[1:3]
    elif len(sys.argv) == 2 and sys.argv[1].isdigit():
        n = int(sys.argv[1])
        a = genRandom(n)
        b = genRandom(n)
    else:
        a = genRandom(10)
        b = genRandom(10)
    return a,b



def genRandom(n):
    return ''.join(choice('ACGT') for _ in range(n))
