# This implementation is modeled off of pages 114-115 of Libeskind-Hadas/Bush text
import sys
sys.setrecursionlimit(2010)

def LCS(X, Y, memo):
    """Return the length of the longest common subsequence of strings X and Y,
    given existing memoization dictionary."""
    if X == '' or Y == '':
        return 0
    elif (X,Y) in memo:
        return memo[(X,Y)]
    else:
        if X[0] == Y[0]:             # leading symbols match
            solution = 1 + LCS(X[1: ], Y[1: ], memo)
        else:
            option1 = LCS(X[1: ], Y, memo)        # ignore first character of X
            option2 = LCS(X, Y[1: ], memo)        # ignore first character of Y
            solution = max(option1, option2)
        memo[(X,Y)] = solution              # remember this case for later
        return solution


# test the function

from generate import parseArgs

X,Y = parseArgs()
print(X,Y)

print('LCS has length %d' % LCS(X,Y,{}))
